<?php
/**
 * Aliases for Special:StructuredDiscussions and Special:EnableStructuredDiscussions
 * @file
 * @license GPL-2.0-or-later
 */

$specialPageAliases = [];

/** English (English) */
$specialPageAliases['en'] = [
	'StructuredDiscussions' => [ 'StructuredDiscussions', 'Flow' ],
	'EnableStructuredDiscussions' => [ 'EnableStructuredDiscussions', 'EnableFlow' ],
];

/** Arabic (العربية) */
$specialPageAliases['ar'] = [
	'StructuredDiscussions' => [ 'سريان' ],
	'EnableStructuredDiscussions' => [ 'فعل_سريان' ],
];

/** Egyptian Arabic (مصرى) */
$specialPageAliases['arz'] = [
	'StructuredDiscussions' => [ 'سريان' ],
];

/** Bengali (বাংলা) */
$specialPageAliases['bn'] = [
	'StructuredDiscussions' => [ 'ফ্লো' ],
	'EnableStructuredDiscussions' => [ 'ফ্লো_সক্রিয়করণ' ],
];

/** Czech (čeština) */
$specialPageAliases['cs'] = [
	'StructuredDiscussions' => [ 'Strukturované_diskuse' ],
	'EnableStructuredDiscussions' => [ 'Povolit_strukturovanou_diskusi' ],
];

/** German (Deutsch) */
$specialPageAliases['de'] = [
	'EnableStructuredDiscussions' => [ 'Flow_aktivieren' ],
];

/** Zazaki (Zazaki) */
$specialPageAliases['diq'] = [
	'StructuredDiscussions' => [ 'Rodayış' ],
];

/** Persian (فارسی) */
$specialPageAliases['fa'] = [
	'StructuredDiscussions' => [ 'جریان' ],
	'EnableStructuredDiscussions' => [ 'فعال‌سازی_جریان' ],
];

/** Hebrew (עברית) */
$specialPageAliases['he'] = [
	'StructuredDiscussions' => [ 'זרימה' ],
	'EnableStructuredDiscussions' => [ 'הפעלת_זרימה' ],
];

/** Hungarian (magyar) */
$specialPageAliases['hu'] = [
	'EnableStructuredDiscussions' => [ 'Flow bekapcsolása' ],
];

/** Korean (한국어) */
$specialPageAliases['ko'] = [
	'StructuredDiscussions' => [ '구조화된토론', '플로우' ],
	'EnableStructuredDiscussions' => [ '구조화된토론활성화', '플로우활성화' ],
];

/** Northern Luri (لۊری شومالی) */
$specialPageAliases['lrc'] = [
	'StructuredDiscussions' => [ 'جأریان' ],
];

/** Macedonian (македонски) */
$specialPageAliases['mk'] = [
	'StructuredDiscussions' => [ 'Тек' ],
	'EnableStructuredDiscussions' => [ 'ОвозможиТек' ],
];

/** Malayalam (മലയാളം) */
$specialPageAliases['ml'] = [
	'StructuredDiscussions' => [ 'പ്രവാഹം' ],
];

/** Portuguese (português) */
$specialPageAliases['pt'] = [
	'StructuredDiscussions' => [ 'Fluência', 'Fluencia' ],
];

/** Brazilian Portuguese (português do Brasil) */
$specialPageAliases['pt-br'] = [
	'EnableStructuredDiscussions' => [ 'Habilitar_Flow' ],
];

/** Swedish (svenska) */
$specialPageAliases['sv'] = [
	'StructuredDiscussions' => [ 'Flöde' ],
];

/** Urdu (اردو) */
$specialPageAliases['ur'] = [
	'StructuredDiscussions' => [ 'مرتب_گفتگو', 'فلو' ],
	'EnableStructuredDiscussions' => [ 'مرتب_گفتگو_فعال_کریں', 'فلو_فعال_کریں' ],
];

/** Vietnamese (Tiếng Việt) */
$specialPageAliases['vi'] = [
	'StructuredDiscussions' => [ 'Flow' ],
	'EnableStructuredDiscussions' => [ 'Kích_hoạt_Flow' ],
];

/** Simplified Chinese (中文（简体）‎) */
$specialPageAliases['zh-hans'] = [
	'StructuredDiscussions' => [ '结构式讨论', '結構式討論' ],
	'EnableStructuredDiscussions' => [ '启用结构式讨论', '启用Flow', '啟用結構式討論', '啟用Flow' ],
];

/** Traditional Chinese (中文（繁體）‎) */
$specialPageAliases['zh-hant'] = [
	'StructuredDiscussions' => [ '結構式討論' ],
	'EnableStructuredDiscussions' => [ '啟用結構式討論', '啟用Flow' ],
];
